stages:
  - build

build-image:
  stage: build
  image:
    # https://docs.gitlab.com/ce/ci/docker/using_kaniko.html
    # >> The kaniko debug image is recommended (gcr.io/kaniko-project/executor:debug) because it has a shell, and a shell is required for an image to be used with GitLab CI/CD.
    name: gcr.io/kaniko-project/executor:debug
    # >> The entrypoint will need to be overridden, otherwise the build script will not run.
    entrypoint: [""]
  tags:
    # The shared runners will only trigger on tagged jobs.
    - docker
  script:
    # Tell kaniko to trust the evernym internal CA.
    - cat "$EVERNYM_CERTIFICATE" >> /kaniko/ssl/certs/ca-certificates.crt
    # establish kaniko's config file from gitlab-runner environment variables
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    # tag docker images based on branch, but override 'master' (gitlab default) with 'latest' (docker default)
    - TAG="$CI_COMMIT_SHORT_SHA"
    # build and upload. https://github.com/GoogleContainerTools/kaniko/blob/master/README.md for additional options
    - /kaniko/executor --context $CI_PROJECT_DIR --destination $CI_REGISTRY_IMAGE:$TAG
